/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/
#ifndef SM_BASE_H_
#define SM_BASE_H_

#include <nw/types.h>
#include <nw/ut.h>
#include <nw/io.h>
#include <nw/os.h>
#include <nw/math.h>
#include <nw/font.h>
#include <nw/lyt.h>
#include <nw/gfx.h>
#include <nw/anim.h>
#include <nw/snd.h>

//------------------------------------------------------------------------------
// Base class
class SmBase
{
public:

    // Constructor
    SmBase(){}

    // Set up an allocator.
    static void SetAllocator(   nw::os::IAllocator* allocator,
                                nw::os::IAllocator* deviceAllocator )
    {
        m_Allocator         = allocator;
        m_DeviceAllocator   = deviceAllocator;
    }

protected:
    static nw::os::IAllocator* m_Allocator;
    static nw::os::IAllocator* m_DeviceAllocator;
};


#endif  // SM_BASE_H_
