/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_FONT_ARCHIVEFONT_H_
#define NW_FONT_ARCHIVEFONT_H_

#include <nn/types.h>
#include <nw/font/font_ArchiveFontBase.h>


namespace nw {
namespace font {

//---------------------------------------------------------------------------
//
//
//---------------------------------------------------------------------------
class ArchiveFont : public ArchiveFontBase
{
public:
    /* ------------------------------------------------------------------------
            Functions
       ------------------------------------------------------------------------ */

    //
    //

    //
                    ArchiveFont();

    //
    virtual         ~ArchiveFont();

    //


    //
    //

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    static u32      GetRequireBufferSize(
                        const void*         bfnt,
                        const char*         glyphGroups = LOAD_GLYPH_ALL
                    );

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    bool            Construct(
                        void*               pBuffer,
                        u32                 bufferSize,
                        const void*         bfnt,
                        const char*         glyphGroups = LOAD_GLYPH_ALL
                    );

    //
    //
    //
    //
    //
    //
    //
    //
    void            InitStreamingConstruct(
                        ConstructContext*   pContext,
                        void*               pBuffer,
                        u32                 bufferSize,
                        const char*         glyphGroups = LOAD_GLYPH_ALL
                    );

    //
    //
    //
    //
    //
    //
    //
    //
    //
    ConstructResult StreamingConstruct(
                        ConstructContext*   pContext,
                        const void*         stream,
                        u32                 streamSize);

    //
    //
    //
    //
    //
    void*           Destroy();

    //

    //
    //

    //
    //
    //
    //
    //
    virtual void    GetGlyph(
                        Glyph*      pGlyph,
                        CharCode    c
                    ) const;

    //

private:
    /* ------------------------------------------------------------------------
            Functions
       ------------------------------------------------------------------------ */
    //---- glyph index

    //
    //
    //
    //
    //
    void            GetGlyphFromIndex(
                        Glyph*      pGlyph,
                        GlyphIndex  index
                    ) const;
};

}   // namespace font
}   // namespace nw

#endif //  NW_FONT_ARCHIVEFONT_H_
