/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "ShaderConfig.h"
#include "VertexShader.h"

    //------------------------------------------
    // Color
    //------------------------------------------

l_calc_color:
    // Vertex color exists if the scale value is not 0.
    mov     TEMP0.y,    nw_attribute_scale0._W
    cmp     NEQ, NEQ,   TEMP0.xy,       CONST_0

    // Set 1 for all colors in advance.
    mov     TEMP_COLO.xyzw,      CONST_1

    ifc 0, 1, COND_MODE_STA1 // When vertex color is enabled.
        // Enters values in advance as a measure against stalls due to an ifb jump.
        mul     TEMP0.xyzw,  nw_color.xyzw,       nw_attribute_scale0._W
        ifb nw_is_vertex_alpha_enable
            mov     TEMP_COLO.w,      TEMP0.w
        endif
        mov     TEMP_COLO.xyz,      TEMP0.xyz
    endif

    callb nw_is_hemi_sphere_lighting, l_calc_hemisphere_lighting // When hemisphere lighting is enabled,

    max     o_Color,    TEMP_COLO,          CONST_0
    ret
