/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "precompiled.h"

#include <nw/gfx/gfx_SceneHelper.h>

namespace nw {
namespace gfx {

// Common processing
void
SceneHelper::ResolveReferenceImpl(SceneNode* parent, SceneNode* child)
{
    NW_NULL_ASSERT(parent);
    NW_NULL_ASSERT(child);

    // If there is a parent for the child, do not check
    if (child->GetParent() != NULL)
    {
        return;
    }

    void* resAddr = child->GetResSceneNode().ptr();
    const int childNum = parent->GetResSceneNode().GetChildrenCount();
    for (int i = 0; i < childNum; ++i)
    {
        void* childResAddr = parent->GetResSceneNode().GetChildren(i).ptr();
        if (ut::ComparePtr(resAddr, childResAddr) == 0)
        {
            // Parent and child
            bool result = parent->AttachChild(child);
            NW_ASSERT(result);

            return;
        }
    }
}

} // namespace gfx
} // namespace nw
