﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "../precompiled.h"

#include <nw/gfx/res/gfx_ResUtil.h>
#include <nw/gfx/res/gfx_ResLight.h>
#include <nw/gfx/res/gfx_ResGraphicsFile.h>

namespace nw {
namespace gfx {
namespace res {

//----------------------------------------
Result
ResFog::Setup(os::IAllocator* allocator, ResGraphicsFile graphicsFile)
{
    NW_UNUSED_VARIABLE(allocator);

    Result result = RESOURCE_RESULT_OK;

    ResReferenceLookupTable refLut =
        ResDynamicCast<ResReferenceLookupTable>(this->GetFogSampler());

    Result referenceResult = SetupReferenceLut(refLut, graphicsFile);

    if (referenceResult.IsSuccess())
    {
        result |= this->GetFogSampler().Setup();
    }

    result |= referenceResult;

    return result;
}

//----------------------------------------
void
ResFog::Cleanup()
{
    ut::SafeCleanup(this->GetFogSampler());
}

} /* namespace res */
} /* namespace gfx */
} /* namespace nw */

