/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_SHADERCONFIG_H_
#define NW_SHADERCONFIG_H_

//----------------------------------------

// Startup offset from the universal system of the user register.
#define nw_user_register_start          c60

// Enables the same camera sphere environment as NW4R.
#define NW_NORMAL_ENV_MAP

// Enabling this macro and setting it in the shader appends a feature that adds an offset to the model's parallel translation value.
// #define NW_GFX_MODEL_TRANSLATE_OFFSET_ENABLED

// Enabling this macro enables code that is a workaround for problem of unintended lines being drawn due to wrap-around of coordinates.
// 
//
// #define NW_GFX_WORKAROUND_WRAP_AROUND_X_COORDINATES
// #define NW_GFX_WORKAROUND_ONE_MINUS_EPSILON 0.9990234375
//
// Here the value for epsilon is 1/1024 so (1 - epsilon) = 1023 / 1024 = 0.9990234375. But set the value that is optimal for the scene being drawn.
// 

// The user adds definitions here and below.

// Enables the sample codes the fix in place the texture input sources.
// #define NW_FIXED_TEX_SORUCE

#endif // NW_SHADERCONFIG_H_
