/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_LYT_RESOURCEACCESSOR_H_
#define NW_LYT_RESOURCEACCESSOR_H_

#include <nw/lyt/lyt_Types.h>

namespace nw
{
namespace font
{

class Font;

}

namespace lyt
{

//
//

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
typedef u32 ResType;

//

//---------------------------------------------------------------------------
//
//
//
//
//
//---------------------------------------------------------------------------
class ResourceAccessor
{
    //----------------------------------------
    //
    //

protected:
    //
    //
    //
    //
    ResourceAccessor();

public:
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual ~ResourceAccessor();

    //

    //----------------------------------------
    //
    //

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual void* GetResource(
        ResType resType,
        const char* name,
        u32* pSize = 0
    ) = 0;

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual font::Font* GetFont(const char* name) = 0;

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual const TextureInfo GetTexture(const char* name) = 0;

    //

protected:
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual const TextureInfo LoadTexture(const char* name);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    virtual font::Font* LoadFont(const char* name);

#if defined(NW_FONT_ENABLE_EDGE_FONT)
public:
    font::FontCombinerType  GetDefaultFontCombiner()  const
    {
        return m_CombinerType;
    }

    void  SetDefaultFontCombiner( font::FontCombinerType combiner )
    {
        m_CombinerType = combiner;
    }

protected:
    font::FontCombinerType  m_CombinerType;
#endif
};

} // namespace nw::lyt
} // namespace nw

#endif // NW_LYT_RESOURCEACCESSOR_H_
