/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW_LYT_TEXTURECONTAINER_H_
#define NW_LYT_TEXTURECONTAINER_H_

#include <nw/ut/ut_LinkList.h>

#include <nw/lyt/lyt_Types.h>

namespace nw
{
namespace lyt
{

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
class TextureRefLink
{
public:
    //
    static const int TEXIMAGE_FILENAME_MAX = 127;

    //----------------------------------------
    //
    //

    //
    TextureRefLink();


    //
    //
    //
    //
    //
    //
    //
    ~TextureRefLink();

    // @}

    //----------------------------------------
    //
    //

    //
    //
    //
    //
    //
    //
    //
    void Set(
        const char* resourceName,
        const TextureInfo& texInfo);

    //
    //
    //
    //
    //
    //
    const char* GetResourceName() const
    {
        return m_Name;
    }

    //
    //
    //
    //
    //
    //
    const TextureInfo GetTextureInfo()
    {
        return m_TexInfo;
    }

    // @}

    //
    //
    ut::LinkListNode m_Link;

protected:
    //
    char m_Name[TEXIMAGE_FILENAME_MAX + 1];

    //
    TextureInfo m_TexInfo;
};

//---------------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
//
//
//---------------------------------------------------------------------------
class TextureContainer : public ut::LinkList<TextureRefLink, offsetof(TextureRefLink, m_Link)>
{
public:
    //----------------------------------------
    //
    //

    //
    //
    //
    //
    //
    //
    //
    ~TextureContainer();

    //

    //----------------------------------------
    //
    //

    //
    //
    //
    //
    //
    //
    //
    void Finalize();

    //
    //
    //
    //
    //
    //
    //
    //
    //
    TextureKey RegistTexture(const char* name, const TextureInfo& textureInfo);

    //
    //
    //
    //
    //
    //
    void UnregistTexture(TextureKey key);

    //

    //----------------------------------------
    //
    //

    //
    //
    //
    //
    //
    //
    //
    //
    //
    const TextureInfo FindTextureByName(const char* name);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    const TextureInfo FindTextureByKey(TextureKey key);

    //
};

} // namespace nw::lyt
} // namespace nw

#endif // NW_LYT_TEXTURECONTAINER_H_
