/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include "precompiled.h"

#include <nw/lyt/lyt_DrawInfo.h>
#include <nw/lyt/lyt_Types.h>
#include <nw/lyt/lyt_Common.h>
#include <nw/lyt/lyt_GraphicsResource.h>

namespace nw
{
namespace lyt
{

DrawInfo::DrawInfo()
:   m_LocationAdjustScale(1.f, 1.f),
    m_GlobalAlpha(1.f),
    m_pGraphicsResource(0),
    m_pLayout(0)
{
    std::memset(&m_Flag, 0, sizeof(m_Flag));

    MTX34Identity(&m_ViewMtx);
}

DrawInfo::~DrawInfo()
{
}

void
DrawInfo::SetProjectionMtx(const nw::math::MTX44& mtx)
{
    // If immediately applied in shaders, there can be multiple versions of DrawInfo which will result in errors in operation, so the value is only held here.
    // 
    // The actual setting occurs using Layout::Draw.
    math::MTX44Copy(&m_ProjMtx, &mtx);
}

} // namespace nw::lyt
} // namespace nw
