/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_SYSTEM_HEAP_PUB_H_
#define NW4C_VIEWER_SYSTEM_HEAP_PUB_H_

#include <nw/os/os_Memory.h>
#include <nw/viewer/types.h>

namespace nw     {
namespace viewer {
namespace sys    {

class App;

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class Heap
{
public:
    //---------------------------------------------------------------------------
    //
    //---------------------------------------------------------------------------
    enum { MEMORY_DEFAULT_ALIGN = 4 };

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    void* Memory_Alloc( u32 size, u32 align = MEMORY_DEFAULT_ALIGN );

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    void* Memory_AllocDevice( u32 size, u32 align = MEMORY_DEFAULT_ALIGN );

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    void  Memory_Free( void* addr );

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    void  Memory_Free( const void* addr );

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    u32   Memory_FreeSize( void );

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    nw::os::IAllocator*   Memory_GetAllocator();

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    nw::os::IAllocator*   Memory_GetAllocatorDevice();

private:
    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    Heap();

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    NW4C_VIEWER_FORBIDDEN_FUNC( Heap );

    friend class App;
};


} // namespace sys
} // namespace viewer
} // namespace nw


#endif /* NW4C_VIEWER_SYSTEM_HEAP_PUB_H_ */

