/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_SYSTEM_MODULE_PUB_H_
#define NW4C_VIEWER_SYSTEM_MODULE_PUB_H_

#include <nw/viewer/types.h>

#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
namespace nw     {
namespace viewer {
namespace sys    {

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class Module
{
public:
    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual void UpdateFrame();

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual void Calc();

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual void Draw( bool sync = true );

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual void DrawInfo();

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual bool IsFocused() const;

protected:
    //----------------------------------------
    //
    //

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    explicit Module( u16 moduleID ) : mID( moduleID ) {}

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    virtual ~Module() {}

    //

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    NW4C_VIEWER_FORBIDDEN_FUNC( Module );

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    u16 mID;

#if defined(NW_PLATFORM_CTR)
    //
    u8 padding[2];
#endif

    friend class App;
};



} // namespace sys
} // namespace viewer
} // namespace nw
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#endif

#endif /* NW4C_VIEWER_SYSTEM_MODULE_PUB_H_ */

