/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_SYSTEM_VIDEOSETTING_PUB_H_
#define NW4C_VIEWER_SYSTEM_VIDEOSETTING_PUB_H_

#include <nw/gfx.h>
#include <nw/ut.h>
#include <nw/viewer/types.h>

namespace nw     {
namespace viewer {
namespace sys    {

class App;

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class VideoSetting
{
public:
    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    nn::math::VEC2 GetSize( u32 display ) const;

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    nw::gfx::RenderColorFormat GetColorFormat() const;

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    nw::gfx::RenderDepthFormat GetDepthFormat() const;

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    nw::ut::FloatColor GetClearColor() const;

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    f32 GetClearZ() const;

    //---------------------------------------------------------------------------
    //
    //
    //
    //
    //
    //
    //---------------------------------------------------------------------------
    void SetScreenSize(u32 width, u32 height);

private:
    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    VideoSetting();

    //---------------------------------------------------------------------------
    //
    //
    //
    //---------------------------------------------------------------------------
    NW4C_VIEWER_FORBIDDEN_FUNC( VideoSetting );

    friend class App;
};


} // namespace sys
} // namespace viewer
} // namespace nw


#endif /* NW4C_VIEWER_SYSTEM_VIDEOSETTING_PUB_H_ */

