/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_MODULE_G3D_H_
#define NW4C_VIEWER_G3D_MODULE_G3D_H_

#include <viewer/system/Module.h>
#include <viewer/system/AppId.h>

namespace vw {
namespace g3d {

//============================================
// ModuleG3d class
//============================================
class ModuleG3d : public system::Module
{
public:
    static ModuleG3d* GetInstance();
    ModuleG3d() : system::Module( system::G3D_ID, system::G3D_PRIORITY, system::G3D_SETUP_ORDER ) {}
    virtual void InitMenu( void ) = 0;
    virtual void InitGraphics( void ) = 0;
};

}   /* namespace g3d */
}   /* namespace vw  */

#endif
