/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/
#ifndef NW4CVIEWER_UTILITY_H_
#define NW4CVIEWER_UTILITY_H_

#include <viewer.h>

namespace vw     {
namespace system {
namespace Utility{

enum ERROR
{
    SUCCESS  = 0,
    NO_ERROR = 0,

    OUT_OF_MEMORY   = 0x000000001,
    INVALID_PARAMS  = 0x000000002
};

/*
  
 */
const char* ErrorToString( ERROR errCode );

/*
  

  
  
  

  
 */
nw::ut::MoveArray<u8> LoadFile( nw::os::IAllocator* allocator, const wchar_t* filePath, u32 align = 32 );

/*
  

  

  
 */
nw::ut::MoveArray<u8> LoadFileFromHost(nw::os::IAllocator* allocator, const wchar_t* filePath, bool *isOnThe32MBLine = NULL);
nw::ut::MoveArray<u8> LoadFileFromHost(nw::os::IAllocator* allocator, const char* filePath, bool *isOnThe32MBLine = NULL);

/*
  
 */
void LOG_ERROR( int errCode );

} // Utility
} // NW4CVIEWER
} // nw

#endif//NW4CVIEWER_UTILITY_H_
