/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_EFFECT_INFO_DRAWER_H_
#define NW4C_VIEWER_EFFECT_INFO_DRAWER_H_



#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
namespace vw  {
namespace effect {


/*===========================================================================*
  Name:         InfoDrawer

  Description:  information display
 *===========================================================================*/
class InfoDrawer
{
public:

    static InfoDrawer* GetInstance();

    // Instance initialization, finalization
    static void Initialize();
    static void Finalize();

    // HID input
    void Main(vw::system::HidStatus &hidStatus);

    // information display
    struct DrawInfo
    {
        const char* SubModeName;
        u32  ParticleCount;
        u32  MaxParticle;
        f32  StepFrame;
        f32  FrameCount;
        f32  MaxFrameCount;
        bool LoopFlag;
    };
    void Draw(const DrawInfo& info);

    // Switches display modes.
    void ChangeRenderInfoFlag();

private:
    // Constructor
    InfoDrawer();
    // Destructor
    ~InfoDrawer();

    s32    mRenderInfoFlag;

    static InfoDrawer*      mInstance;
    void DrawSeekBar(f32 frameCount, f32 maxFrame);
};



}   /* namespace effect */
}   /* namespace vw  */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#endif


/* NW4C_VIEWER_EFFECT_INFO_DRAWER_H_ */
#endif
