﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_ERROR_CHECK_H_
#define NW4C_VIEWER_G3D_ERROR_CHECK_H_

#include <viewer.h>

namespace vw  {
namespace g3d {


class ErrorCheck
{
public:
    static void CheckModelTextureCombiner( nw::gfx::Model* model );
    static void CheckModelTextureReference( nw::gfx::Model* model );
    static void CheckModelLookupTableReference( nw::gfx::Model* model );
    static void CheckModelFogIndexBoundary( nw::gfx::Model* model );
    static void CheckModelFogIndexReference( nw::gfx::Model* model );
    static void CheckModelLightSetIndexBoundary( nw::gfx::Model* model );
    static void CheckModelLightSetIndexReference( nw::gfx::Model* model );
    static void CheckModelCameraReferenceIndexBoundary( nw::gfx::Model* model );
    static void CheckModelCameraReferenceIndexReference( nw::gfx::Model* model );
    static void CheckCameraNear( nw::gfx::Camera* camera );
    static void CheckCameraNearFar( nw::gfx::Camera* camera );
    static void CheckCameraPosition( nw::gfx::Camera* camera );
    static void CheckCameraUpVectorZero( nw::gfx::Camera* camera );
    static void CheckCameraUpVectorParallel( nw::gfx::Camera* camera );
    static void CheckLightLookupTableReference( nw::gfx::Light* light );
    static void CheckSceneEnvironmentSetting( nw::gfx::SceneEnvironmentSetting* scene );
    static void Error_VertexLight_Disalbe();
    static void Error_VRAM_Alloc();
};


}   /* namespace g3d */
}   /* namespace vw  */


/* NW4C_VIEWER_G3D_ERROR_CHECK_H_ */
#endif
