﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_G3D_SUB_MODE_MANAGER_H_
#define NW4C_VIEWER_G3D_SUB_MODE_MANAGER_H_

#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 2530 // padding added to end of struct.
#endif
namespace vw {
namespace g3d {

class ISubMode;

enum SubModeType
{
    SubMode_Camera = 0,
    SubMode_Menu,
    SubMode_Log
};

class SubModeManagerBase
{
public:
    virtual void Main(vw::system::HidStatus &hidStatus);
    virtual void Draw();
    void SetMode(SubModeType);
    SubModeType GetCurrentModeType() const;
    const char* GetCurrentModeName() const;

protected:
    SubModeManagerBase();
    virtual ~SubModeManagerBase();
    nw::ut::MoveArray<ISubMode*> mMode;
    int mCurrentModeIndex;
};

class SubModeManager : public SubModeManagerBase
{
public:
    static SubModeManager* GetInstance();
    static void Initialize();
    static void Finalize();
    void GetTouchPanelEvent(const vw::system::HidStatus &hidStatus);

protected:
    SubModeManager();
    virtual ~SubModeManager();

    static SubModeManager* m_pInstance;
    bool mTouch;
};


}   /* namespace g3d */
}   /* namespace vw  */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 2530 // padding added to end of struct.
#endif

#endif
