/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NW4C_VIEWER_SYSTEM_TPEG_READER_IMPL_H_
#define NW4C_VIEWER_SYSTEM_TPEG_READER_IMPL_H_

#include "ImageReader.h"

#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_suppress 1301 // padding inserted in struct.
#endif
namespace vw     {
namespace system {

class JpegReaderImpl : public ImageReaderImpl
{
//--- Public members ------
public:
    /* ctor */          JpegReaderImpl( void* data, u32 dataSize );
    /* dtor */ virtual  ~JpegReaderImpl();

    virtual bool        IsValid()   { return mValid;  }
    virtual u32         GetWidth()  { return mWidth;  }
    virtual u32         GetHeight() { return mHeight; }
    virtual bool        Expand( void* expBuf, u32 bufWidth, u32 bufHeight );
    virtual u32         GetType() { return TYPE_JPEG; }
    virtual void        Dispose();

//--- Private members ------
private:
    bool    mValid;
    void*   mBuf;
    u32     mHeight;
    u32     mWidth;
    void*   mDecBuf;
};



}   /* namespace system */
}   /* namespace vw     */
#if NN_CURRENT_VERSION_NUMBER >= NN_VERSION_NUMBER(4,0,0,0)
#pragma diag_default 1301 // padding inserted in struct.
#endif


/* NW4C_VIEWER_SYSTEM_TPEG_READER_IMPL_H_ */
#endif
