﻿/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

//#include <revolution/mem.h>
#include <nw/viewer/sys/Application.h>
#include <viewer/system.h>

namespace nw     {
namespace viewer {
namespace sys    {

/*---------------------------------------------------------------------------*
  Name:         Module::UpdateFrame

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
Module::UpdateFrame()
{
    vw::system::Module* module = vw::system::App::GetModuleInstance( mID );
    if ( ! module )
    {
        return;
    }
    module->UpdateFrame();
}


/*---------------------------------------------------------------------------*
  Name:         Module::Calc

  Description:

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
Module::Calc()
{
    vw::system::Module* module = vw::system::App::GetModuleInstance( mID );
    if ( ! module )
    {
        return;
    }
    module->Calc();
}

/*---------------------------------------------------------------------------*
  Name:         Module::Draw

  Description:

  Arguments:    sync

  Returns:      None.
 *---------------------------------------------------------------------------*/
void
Module::Draw( bool sync /* = true */ )
{
    vw::system::Module* module = vw::system::App::GetModuleInstance( mID );
    if ( ! module )
    {
        return;
    }
    module->Draw();
}

/*---------------------------------------------------------------------------*
  Name:         Module::DrawInfo

  Description:

  Arguments:    None.

  Returns:
 *---------------------------------------------------------------------------*/
void
Module::DrawInfo()
{
    vw::system::Module* module = vw::system::App::GetModuleInstance( mID );
    if ( ! module )
    {
        return;
    }
    module->DrawInfo();
}

/*---------------------------------------------------------------------------*
  Name:         Module::IsFocused

  Description:

  Arguments:    None.

  Returns:
 *---------------------------------------------------------------------------*/
bool
Module::IsFocused() const
{
    return vw::system::App::GetInstance().HasFocus( mID );
}


} /* namespace sys    */
} /* namespace viewer */
} /* namespace nw     */





