/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include <nw/viewer/sys/VideoSetting.h>
#include <viewer/system.h>
#include <viewer/g3d.h>

namespace nw     {
namespace viewer {
namespace sys    {

/*---------------------------------------------------------------------------*
  Name:         VideoSetting::VideoSetting

  Description:  Constructor

  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
/* ctor */
VideoSetting::VideoSetting()
{
}

nw::gfx::RenderColorFormat
VideoSetting::GetColorFormat() const
{
    vw::system::VideoSetting setting;
    vw::system::Video_GetSetting( &setting );
    return setting.colorFormat;
}

nw::gfx::RenderDepthFormat
VideoSetting::GetDepthFormat() const
{
    vw::system::VideoSetting setting;
    vw::system::Video_GetSetting( &setting );
    return setting.depthFormat;
}

nw::ut::FloatColor
VideoSetting::GetClearColor() const
{
    vw::system::VideoSetting setting;
    vw::system::Video_GetSetting( &setting );
    return setting.clearColor;
}

f32
VideoSetting::GetClearZ() const
{
    vw::system::VideoSetting setting;
    vw::system::Video_GetSetting( &setting );
    return setting.clearZ;
}

void
VideoSetting::SetScreenSize(u32 width, u32 height)
{
    vw::system::Video_SetScreenSize(width, height);
}

} /* namespace sys    */
} /* namespace viewer */
} /* namespace nw     */





