/*---------------------------------------------------------------------------*
  Project:  NintendoWare

  Copyright (C)Nintendo/HAL Laboratory, Inc.  All rights reserved.

  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.

  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/

#include <viewer/system.h>
#include "../include/ModuleTemplateImpl.h"


namespace vw {
namespace tmpl {

static ModuleTemplateImpl sModuleTemplate;
ModuleTemplate* ModuleTemplate::GetInstance() { return &sModuleTemplate; }

// When changing the target mode, whether it is permitted to move the focus to TEMPLATE mode is determined by the IsHidden() method.
// Variable to dynamically set with these conditions.
#ifdef NW_BUILD_SCONS
bool    ModuleTemplateImpl::sHiddenFlag = true;
#else
bool    ModuleTemplateImpl::sHiddenFlag = false;
#endif

/*---------------------------------------------------------------------------*
  Name:         ModuleTemplateImpl::Init
  Description:  Template module initialization function
  Arguments:    None.
  Returns:      None.
 *---------------------------------------------------------------------------*/
void
ModuleTemplateImpl::Init( void )
{

}

/*---------------------------------------------------------------------------*
  Name:         ModuleTemplateImpl::Main
  Description:  The Main function of the template module
  Arguments:    pad  Gets the status of the pad assigned to the template module.
  Returns:      None.
 *---------------------------------------------------------------------------*/
void
ModuleTemplateImpl::Main( vw::system::HidStatus &hidStatus )
{

}

/*---------------------------------------------------------------------------*
  Name:         ModuleSampleImpl::DrawInfo
  Description:  Function to display information on the screen
  Arguments:    None.
  Returns:      None.
 *---------------------------------------------------------------------------*/
void
ModuleTemplateImpl::DrawInfo( void )
{
    vw::system::Video_SetRenderTarget(vw::system::LOWER_SCREEN);
    vw::system::Video_GetRenderContext()->ResetState();
    vw::system::FontDrawer& font = vw::system::FontDrawer::GetInstance();
    font.BeginDraw();
    font.DrawString(2,20,"Template");
    font.EndDraw();
}


}   /* namespace sample */
}   /* namespace vw  */
